## gcl27 2.7.0

=== gmp4/mini-gmp/tests/Makefile ===
# Note: Requires GNU make

# Copyright 2011, 2012, 2014 Free Software Foundation, Inc.
#
# This file is part of the GNU MP Library test suite.
#
# The GNU MP Library test suite is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the License,
# or (at your option) any later version.
#
# The GNU MP Library test suite is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# the GNU MP Library test suite.  If not, see https://www.gnu.org/licenses/.

srcdir=.
MINI_GMP_DIR=..

CC = gcc
EXTRA_CFLAGS = -O -Wall -g
CFLAGS = $(EXTRA_CFLAGS) -I$(MINI_GMP_DIR)
LDFLAGS =

LIBS = -lgmp -lm -lmcheck

CHECK_PROGRAMS = t-add t-sub t-mul t-invert t-div t-div_2exp \
	t-double t-cmp_d t-gcd t-lcm t-import t-comb t-signed \
	t-sqrt t-root t-powm t-logops t-bitops t-scan t-str \
	t-reuse t-aorsmul t-limbs t-cong t-pprime_p

MISC_OBJS = hex-random.o mini-random.o testutils.o

all:

clean:
	rm -f *.o $(CHECK_PROGRAMS)

%: %.c
.c:

# Keep object files
.PRECIOUS: %.o

%.o: %.c $(MINI_GMP_DIR)/mini-gmp.h hex-random.h mini-random.h
	$(CC) $(CFLAGS) -c $< -o $@

testutils.o: $(MINI_GMP_DIR)/mini-gmp.c

%: %.o $(MISC_OBJS)
	$(CC) $(LDFLAGS) $^ $(LIBS) -o $@

# Missing tests include:
#   mpz_cmp_d, mpz_popcount, mpz_hamdist, mpz_ui_pow_ui

check: $(CHECK_PROGRAMS)
	$(srcdir)/run-tests $(CHECK_PROGRAMS)

=== debian/changelog ===
gcl27 (2.7.0-35) unstable; urgency=medium

  * Version_2_7_0pre38
  * Bug fix: "ftbfs with GCC-15", thanks to Matthias Klose (Closes:
    #1096686).

 -- Camm Maguire <camm@debian.org>  Thu, 06 Mar 2025 10:54:11 -0500

gcl27 (2.7.0-34) unstable; urgency=medium

  * Version_2_7_0pre37
  * Bug fix: "outdated debconf version constraint; inhibits support for
    debconf-2.0/cdebconf", thanks to Gioele Barabucci (Closes: #1096166).

 -- Camm Maguire <camm@debian.org>  Tue, 18 Feb 2025 12:50:30 -0500

gcl27 (2.7.0-33) unstable; urgency=medium

  * Version_2_7_0pre36

 -- Camm Maguire <camm@debian.org>  Sat, 08 Feb 2025 15:29:48 -0500

gcl27 (2.7.0-32) unstable; urgency=medium

  * Version_2_7_0pre35

 -- Camm Maguire <camm@debian.org>  Sun, 02 Feb 2025 12:00:42 -0500

gcl27 (2.7.0-31) unstable; urgency=medium

  * Version_2_7_0pre34

 -- Camm Maguire <camm@debian.org>  Fri, 17 Jan 2025 18:42:15 -0500

gcl27 (2.7.0-30) unstable; urgency=medium

  * Version_2_7_0pre33

 -- Camm Maguire <camm@debian.org>  Fri, 27 Dec 2024 13:21:13 -0500

gcl27 (2.7.0-29) unstable; urgency=medium

  * Version_2_7_0pre32

 -- Camm Maguire <camm@debian.org>  Mon, 09 Dec 2024 10:00:39 -0500

gcl27 (2.7.0-28) unstable; urgency=medium

  * Version_2_7_0pre31

 -- Camm Maguire <camm@debian.org>  Wed, 04 Dec 2024 13:25:14 -0500

gcl27 (2.7.0-27) unstable; urgency=medium

  * Version_2_7_0pre30

 -- Camm Maguire <camm@debian.org>  Wed, 04 Dec 2024 07:48:31 -0500

gcl27 (2.7.0-26) unstable; urgency=medium

  * Version_2_7_0pre29

 -- Camm Maguire <camm@debian.org>  Sat, 23 Nov 2024 11:33:30 -0500

gcl27 (2.7.0-25) unstable; urgency=medium

  * Bug fix: "needs rebuild against dh-elpa &gt;=2.1.5", thanks to
    spwhitton@spwhitton.name</a>; (Closes: #1077103).

 -- Camm Maguire <camm@debian.org>  Sun, 28 Jul 2024 12:07:24 -0400

gcl27 (2.7.0-24) unstable; urgency=medium

  * Version_2_7_0pre27

 -- Camm Maguire <camm@debian.org>  Fri, 19 Jul 2024 15:04:27 -0400

gcl27 (2.7.0-23) unstable; urgency=medium

  * Version_2_7_0pre26

 -- Camm Maguire <camm@debian.org>  Sun, 28 Apr 2024 22:13:09 -0400

gcl27 (2.7.0-22) unstable; urgency=medium

  * Version_2_7_0pre25

 -- Camm Maguire <camm@debian.org>  Sun, 28 Apr 2024 07:55:48 -0400

gcl27 (2.7.0-21) unstable; urgency=high

  * Version_2_7_0pre24
  * Bug fix: "recent libc6-dev change causes XDR support to be dropped",
    thanks to Aurelien Jarno (Closes: #1065207).

 -- Camm Maguire <camm@debian.org>  Fri, 15 Mar 2024 20:00:19 -0400

gcl27 (2.7.0-20) unstable; urgency=medium

  * Version_2_7_0pre23

 -- Camm Maguire <camm@debian.org>  Thu, 29 Feb 2024 06:51:25 -0500

gcl27 (2.7.0-19) unstable; urgency=medium

  * Version_2_7_0pre22

 -- Camm Maguire <camm@debian.org>  Wed, 28 Feb 2024 13:35:45 -0500

gcl27 (2.7.0-18) unstable; urgency=medium

  * Version_2_7_0pre21

 -- Camm Maguire <camm@debian.org>  Sat, 24 Feb 2024 08:40:29 -0500

gcl27 (2.7.0-17) unstable; urgency=medium

  * Version_2_7_0pre20

 -- Camm Maguire <camm@debian.org>  Fri, 23 Feb 2024 12:23:51 -0500

gcl27 (2.7.0-16) unstable; urgency=medium

  * Version_2_7_0pre19

 -- Camm Maguire <camm@debian.org>  Thu, 22 Feb 2024 22:03:20 -0500

gcl27 (2.7.0-15) unstable; urgency=medium

  * Version_2_7_0pre18

 -- Camm Maguire <camm@debian.org>  Thu, 22 Feb 2024 15:00:44 -0500

gcl27 (2.7.0-14) unstable; urgency=medium

  * Version_2_7_0pre17

 -- Camm Maguire <camm@debian.org>  Wed, 21 Feb 2024 08:03:46 -0500

gcl27 (2.7.0-13) unstable; urgency=medium

  * Version_2_7_0pre16

 -- Camm Maguire <camm@debian.org>  Wed, 21 Feb 2024 00:17:54 -0500

gcl27 (2.7.0-12) unstable; urgency=medium

  * Version_2_7_0pre15

 -- Camm Maguire <camm@debian.org>  Mon, 19 Feb 2024 19:08:05 -0500

gcl27 (2.7.0-11) unstable; urgency=medium

  * Version_2_7_0pre14

 -- Camm Maguire <camm@debian.org>  Mon, 19 Feb 2024 11:04:51 -0500

gcl27 (2.7.0-10) unstable; urgency=medium

  * Version_2_7_0pre13

 -- Camm Maguire <camm@debian.org>  Sun, 28 Jan 2024 20:17:32 -0500

gcl27 (2.7.0-9) unstable; urgency=medium

  * Version_2_7_0pre12

 -- Camm Maguire <camm@debian.org>  Sun, 28 Jan 2024 18:09:15 -0500

gcl27 (2.7.0-8) unstable; urgency=medium

  * Version_2_7_0pre11

 -- Camm Maguire <camm@debian.org>  Sun, 28 Jan 2024 10:36:24 -0500

gcl27 (2.7.0-7) unstable; urgency=medium

  * Version_2_7_0pre10

 -- Camm Maguire <camm@debian.org>  Sat, 27 Jan 2024 12:35:03 -0500

gcl27 (2.7.0-6) unstable; urgency=medium

  * Version_2_7_0pre9

 -- Camm Maguire <camm@debian.org>  Thu, 21 Dec 2023 15:02:31 -0500

gcl27 (2.7.0-5) unstable; urgency=medium

  * Version_2_7_0pre8

 -- Camm Maguire <camm@debian.org>  Thu, 21 Dec 2023 13:08:00 -0500

gcl27 (2.7.0-4) unstable; urgency=medium

  * Version_2_7_0pre7

 -- Camm Maguire <camm@debian.org>  Thu, 21 Dec 2023 09:37:49 -0500

gcl27 (2.7.0-3) unstable; urgency=medium

  * Version_2_7_0pre5

 -- Camm Maguire <camm@debian.org>  Wed, 20 Dec 2023 19:47:35 -0500

gcl27 (2.7.0-2) unstable; urgency=medium

  * Version_2_7_0pre4

 -- Camm Maguire <camm@debian.org>  Wed, 20 Dec 2023 16:01:04 -0500

gcl27 (2.7.0-1) unstable; urgency=medium

  * Version_2_7_0pre3

 -- Camm Maguire <camm@debian.org>  Thu, 14 Dec 2023 16:20:45 -0500

gcl (2.6.13-5) unstable; urgency=medium

  * Version_2_6_14pre4

 -- Camm Maguire <camm@debian.org>  Sun, 25 Dec 2022 07:14:33 -0500

gcl (2.6.13-4) unstable; urgency=medium

  * Version_2_6_14pre3

 -- Camm Maguire <camm@debian.org>  Fri, 23 Dec 2022 11:34:35 -0500

gcl (2.6.13-3) unstable; urgency=medium

  * Version_2_6_14pre2

 -- Camm Maguire <camm@debian.org>  Thu, 22 Dec 2022 19:09:24 -0500

gcl (2.6.13-2) unstable; urgency=medium

  * Version_2_6_14pre1

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 14:40:21 -0500

gcl (2.6.13-1) unstable; urgency=medium

  * New Upstream Release

 -- Camm Maguire <camm@debian.org>  Tue, 20 Dec 2022 10:35:44 -0500

gcl (2.6.12-131) unstable; urgency=medium

  * Version_2.6.13pre131



=== debian/control ===
Source: gcl27
Section: lisp
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Homepage: http://gnu.org/software/gcl
Build-Depends: debhelper (>= 13), libeditreadline-dev, m4, tk8.6-dev, libgmp-dev, libxmu-dev, libxaw7-dev, po-debconf, zlib1g-dev, tcl, texinfo, texlive-latex-base, libtirpc-dev
Build-Depends-Indep: dh-elpa
Standards-Version: 4.5.0

Package: gcl27
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ucf, libtirpc-dev
Suggests: gcl27-doc
Description: GNU Common Lisp compiler
 GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
 implemented in C, and complying mostly with the standard set 
 forth in the book "Common Lisp, the Language I".  It attempts
 to strike a useful middle ground in performance and portability
 from its design around C.
 .
 This package contains the Lisp system itself.  Documentation 
 is provided in the gcl-doc package.

Package: gcl27-tk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcl27 (>= ${source:Version})
Description: GNU Common Lisp compiler
 GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
 implemented in C, and complying mostly with the standard set 
 forth in the book "Common Lisp, the Language I".  It attempts
 to strike a useful middle ground in performance and portability
 from its design around C.
 .
 This package contains a graphical interface based on the popular
 TCL/TK toolkit.

Package: elpa-gcl27
Architecture: all
Depends: gcl27 (>= ${source:Version}), emacs-gtk | emacsen, ${misc:Depends}
Section: lisp
Description: GNU Common Lisp compiler
 GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
 implemented in C, and complying mostly with the standard set 
 forth in the book "Common Lisp, the Language I".  It attempts
 to strike a useful middle ground in performance and portability
 from its design around C.
 .
 This package contains an emacs interface to GCL.

Package: gcl27-doc
Section: doc
Architecture: all
Conflicts: gclinfo
Replaces: gclinfo
Depends: dpkg (>= 1.15.4), ${misc:Depends}
Description: Documentation for GNU Common Lisp
 GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
 implemented in C, and complying mostly with the standard set 
 forth in the book "Common Lisp, the Language I".  It attempts
 to strike a useful middle ground in performance and portability
 from its design around C.
 .
 This package contains documentation in info format of the
 system internals.

Package: gcl27-tk-doc
Section: doc
Architecture: all
Conflicts: gclinfo
Replaces: gclinfo
Depends: dpkg (>= 1.15.4), ${misc:Depends}
Description: Documentation for GNU Common Lisp
 GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
 implemented in C, and complying mostly with the standard set 
 forth in the book "Common Lisp, the Language I".  It attempts
 to strike a useful middle ground in performance and portability
 from its design around C.
 .
 This package contains documentation in info format of the
 graphical interface currently implemented in Tcl/Tk.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
# GNU copyright 2024 Camm Maguire
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

#export GCL_MEM_MULTIPLE=0.1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# This is the debhelper compatability version to use.
ARCHT:=$(shell dpkg-architecture -qDEB_HOST_ARCH)

MCC?=gcc
# ifeq ($(ARCHT),alpha)
# MCC:=gcc-4.6
# endif
# ifeq ($(ARCHT),mips)
# MCC:=gcc-4.6
# endif
# ifeq ($(ARCHT),mipsel)
# MCC:=gcc-4.6
# endif
# ifeq ($(ARCHT),ia64)
# MCC:=gcc-4.6
# endif
# ifeq ($(ARCHT),armel)
# MCC:=gcc-4.6
# endif
# ifeq ($(ARCHT),armhf)
# MCC:=gcc-4.6
# endif

#RELOC=locbfd
#RELOC?=statsysbfd
RELOC?=custreloc
ifeq ($(ARCHT),ia64)
RELOC=dlopen
endif
# ifeq ($(ARCHT),ppc64)
# RELOC=dlopen
# endif
#ifeq ($(ARCHT),hppa)
#RELOC=dlopen
#endif

GMP?=

DEBUG=

ARCHCONF?=
ifeq ($(ARCHT),armhf)
ARCHCONF=--enable-cstackmax=0xc0000000
endif
ifeq ($(ARCHT),armel)
ARCHCONF=--enable-cstackmax=0xc0000000
endif
ifeq ($(ARCHT),hppa)
ARCHCONF=--enable-cstackmax=0xc0000000
endif


#ifeq ($(ARCHT),hppa)
#DEBUG=--enable-debug
#endif

VERS=$(shell echo $$(cat majvers).$$(cat minvers))
EXT=$(shell echo $(VERS) | sed 's,\([0-9]\)\.\([0-9]\)\..*,\1\2,')
#EXT:=cvs

CFG:=$(addsuffix /config.,.)# gmp4/configfsf.
# Bug in autoconf dependency on emacsen-common workaround
#CFGS:=$(addsuffix .ori,configure $(addsuffix guess,$(CFG)) $(addsuffix sub,$(CFG)))
CFGS:=$(addsuffix .ori,$(addsuffix guess,$(CFG)) $(addsuffix sub,$(CFG)))

$(filter %.guess.ori,$(CFGS)): %.ori: /usr/share/misc/config.guess %
	! [ -e $* ] || [ -e $@ ] || cp $* $@
	[ $$($< -t | tr -d '-') -le $$(./$* -t | tr -d '-') ] || cp $< $*
	touch $@

$(filter %.sub.ori,$(CFGS)): %.ori: /usr/share/misc/config.sub %
	! [ -e $* ] || [ -e $@ ] || cp $* $@
	[ $$($< -t | tr -d '-') -le $$(./$* -t | tr -d '-') ] || cp $< $*
	touch $@

configure.ori: %.ori: configure.in 
	! [ -e $* ] || [ -e $@ ] || cp $* $@
	cd $(@D) && autoconf 
	touch $@

configure-%-stamp: $(CFGS)

	dh_testdir

	! [ -e unixport/saved_pre_gcl ] || $(MAKE) clean

#	chmod -R +x gmp4/*

	[ "$*" != "trad" ] || FLAGS="--disable-ansi" ; \
	[ "$*" != "gprof" ] || FLAGS="--disable-ansi --enable-gprof" ; \
	[ "$*" != "ansi-gprof" ] || FLAGS="--enable-gprof" ; \
	eval `dpkg-buildflags --export=sh` && CC=$(MCC) ./configure \
		--host=$$(dpkg-architecture -qDEB_HOST_GNU_TYPE) \
		--disable-statsysbfd \
		--disable-custreloc \
		--disable-dlopen \
		--disable-prelink \
		--disable-pargcl \
		--enable-$(RELOC) \
		$(GMP) \
		$(DEBUG) \
		$(ARCHCONF) \
		$$FLAGS \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--enable-infodir=\$${prefix}/share/info \
		--enable-emacsdir=\$${prefix}/share/emacs/site-lisp

	touch $@

debian/elpa-gcl$(EXT).elpa: debian/gcl$(EXT)-pkg.el
	find elisp -name "*.el" >$@
#	echo debian/gcl$(EXT).el >> debian/elpa-gcl$(EXT).elpa
	echo debian/gcl$(EXT)-pkg.el >> debian/elpa-gcl$(EXT).elpa
	echo debian/debian-autoloads.el >> debian/elpa-gcl$(EXT).elpa

VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)

debian/gcl$(EXT)-pkg.el: debian/gcl-pkg.el.in
	cat $< | sed "s,@VR@,$$(echo $(VR) | sed 's,[a-zA-Z]*,,g'),g" | sed "s,@EXT@,$(EXT),g" > $@


build-%-stamp: configure-%-stamp
	dh_testdir

	$(MAKE)

	rm -rf debian/$*
	mkdir -p debian/$*
	$(MAKE) install DESTDIR=$$(pwd)/debian/$*
	[ "$(findstring gprof,$*)" = "" ] || (\
		tmp=debian/$*; old=/usr/lib/gcl-$(VERS); new=$$old-prof;\
		if [ "$(findstring ansi,$*)" = "" ] ; then i=saved_gcl ; else i=saved_ansi_gcl ; fi;\
		mv $$tmp/$$old $$tmp/$$new ;\
		echo "(si::reset-sys-paths \"$$new/\")(si::save-system \"debian/tmp-image\")" | $$tmp/$$new/unixport/$$i &&\
		mv debian/tmp-image $$tmp/$$new/unixport/$$i;)

	touch $@

configure-stamp: $(CFGS)

	dh_testdir

#	! [ -e unixport/saved_pre_gcl ] || $(MAKE) clean

#	chmod -R +x gmp4/*

	eval `dpkg-buildflags --export=sh` && CC=$(MCC) ./configure \
		--host=$$(dpkg-architecture -qDEB_HOST_GNU_TYPE) \
		--disable-statsysbfd \
		--disable-custreloc \
		--disable-dlopen \
		--disable-prelink \
		--disable-pargcl \
		--enable-$(RELOC) \
		$(GMP) \
		$(DEBUG) \
		$(ARCHCONF) \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--enable-infodir=\$${prefix}/share/info \
		--enable-emacsdir=\$${prefix}/share/emacs/site-lisp

	touch $@


build-stamp: configure-stamp
	dh_testdir

	rm -rf debian/tmp1
	mkdir -p debian/tmp1
	$(MAKE)
	$(MAKE) install DESTDIR=$$(pwd)/debian/tmp1

	touch $@

bclean-stamp:
	$(MAKE) clean
	touch $@

ansi-tests/test_results: build-ansi-stamp
	$(MAKE) $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
#build-stamp: build-gprof-stamp build-ansi-gprof-stamp build-trad-stamp build-ansi-stamp ansi-tests/test_results
	touch $@

# debian/control.rm:
# 	rm -f `echo $@ | sed 's,\.rm$$,,1'`

# debian/control: debian/control.rm
# 	cp debian/control_$(EXT) debian/control

debian/control: debian/control_$(EXT)
	cp $< $@

clean: debian/control debian/gcl.templates
	dh_testdir
	dh_testroot
	rm -f *stamp
	debconf-updatepo

	$(MAKE) clean

	dh_clean
	rm -rf debian/gprof debian/ansi-gprof debian/trad debian/ansi $(INS) debian/substvars debian.upstream
	rm -rf *stamp build-indep debian/tmp1
	for i in $(CFGS) ; do ! [ -e $$i ] || mv $$i $${i%.ori} ; done
	rm -f debian/elpa-gcl$(EXT).elpa debian/gcl$(EXT)-pkg.el

INS:=$(shell for i in `find debian -name "in.*"` ; do echo $$i | sed 's,in.,,1' ; done |sed "s,\([^x]gcl\),\1$(EXT),g")

gcl$(EXT)% : in.gcl%
	cat $< | sed 's,@EXT@,$(EXT),g' >$@

#$(INS): debian/gcl$(EXT)% : debian/in.gcl%
#	cat $< | sed 's,@EXT@,$(EXT),g' >$@

#$(INS): debian/source/gcl$(EXT)% : debian/source/in.gcl%
#	cat $< | sed 's,@EXT@,$(EXT),g' >$@


install: DH_OPTIONS:=
install: install-stamp
install-stamp: build-stamp debian/control $(INS)
	dh_testdir
	dh_testroot
#	dh_clean -k
	dh_prep
	dh_installdirs

#	mkdir -p debian/tmp
	cp -a debian/tmp1 debian/tmp

#	cp -a debian/ansi/* debian/tmp/
#	cp -a debian/trad/* debian/tmp/
#	cp -a debian/gprof/* debian/tmp/
#	cp -a debian/ansi-gprof/* debian/tmp/

#	mv debian/tmp/usr/share/emacs/site-lisp debian/tmp/usr/share/emacs/foo
#	mkdir -p debian/tmp/usr/share/emacs/site-lisp
#	mv debian/tmp/usr/share/emacs/foo debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)

#	cat debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/gcl.el |\
#		sed "s,(provide 'gcl),(provide 'gcl$(EXT)),1" >tmp &&\
#		mv tmp debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/gcl$(EXT).el
#	[ "$(EXT)" = "" ] || rm debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/gcl.el

#	cat debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/dbl.el |\
#		sed -e "s,(provide 'dbl),(provide 'dbl$(EXT)),1" -e "s,(require 'gcl),(require 'gcl$(EXT)),1" >tmp &&\
#		mv tmp debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/dbl$(EXT).el
#	[ "$(EXT)" = "" ] || rm debian/tmp/usr/share/emacs/site-lisp/gcl$(EXT)/dbl.el

	[ "$(EXT)" = "" ] || \
		for i in debian/tmp/usr/share/info/*.info*; do \
			mv $$i $$(echo $$i | sed "s,gcl,gcl$(EXT),g"); done

	mv debian/tmp/usr/share/doc debian/tmp/usr/share/foo
	mkdir -p debian/tmp/usr/share/doc/gcl
	mv debian/tmp/usr/share/foo/* debian/tmp/usr/share/doc/gcl
	rmdir debian/tmp/usr/share/foo

	[ "$(EXT)" = "" ] || \
		mv debian/tmp/usr/share/doc/gcl debian/tmp/usr/share/doc/gcl$(EXT) 

	[ "$(EXT)" = "" ] || \
		(mv debian/tmp/usr/share/man/man1/gcl.1 debian/foo && cat debian/foo |sed -e 's, gcl , gcl$(EXT) ,g' -e 's, GCL , GCL$(EXT) ,g' >debian/tmp/usr/share/man/man1/gcl$(EXT).1)

	# cat debian/tmp/usr/lib/gcl-$(VERS)/gcl-tk/demos/index.lsp | \
	# 	sed "s,$$(pwd)/debian/tmp,,1" >debian/foo
	# mv debian/foo debian/tmp/usr/lib/gcl-$(VERS)/gcl-tk/demos/index.lsp

	rm -f debian/tmp/usr/bin/*.exe debian/tmp/usr/bin/*.bat

	find debian/tmp -type f -name "*.lsp" -exec chmod ugo-x {} \;

=== debian/watch ===
version=4
options=pasv,pgpsigurlmangle=s/$/.sig/ ftp://ftp.gnu.org/pub/gnu/gcl	gcl-([0-9.]*).tar.gz	debian	uupdate

## gcl27 2.7.1

=== debian/changelog ===
gcl27 (2.7.1-8) unstable; urgency=medium

  * Bug fix: "FTBFS: /tmp/gazonk_6005_0.c:21:63: error: implicit
    declaration of function &#39;__builtin_c23_va_start&#39;; did you mean
    &#39;__builtin_ms_va_start&#39;? [-Wimplicit-function-declaration]",
    thanks to Santiago Vila (Closes: #1114119).
  * Version_2_7_2pre7

 -- Camm Maguire <camm@debian.org>  Sun, 21 Sep 2025 14:06:45 -0400

gcl27 (2.7.1-7) unstable; urgency=medium

  * Version_2_7_2pre6
  * Bug fix: "[INTL:nl] Dutch debconf templates translation", thanks to Frans Spiesschaert (Closes: #1106482).

 -- Camm Maguire <camm@debian.org>  Thu, 29 May 2025 19:11:18 -0400

gcl27 (2.7.1-6) unstable; urgency=medium

  * Version_2_7_2pre5

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 02:58:40 -0400

gcl27 (2.7.1-5) unstable; urgency=medium

  * Version_2_7_2pre4
  * Bug fix: "[INTL:pt] Portuguese translation - debconf messages", thanks
    to Américo Monteiro (Closes: #1104887).
  * Bug fix: "[INTL:de] updated German debconf translation", thanks to
    Helge Kreutzmann (Closes: #1104918).

 -- Camm Maguire <camm@debian.org>  Sat, 10 May 2025 19:27:15 -0400

gcl27 (2.7.1-4) unstable; urgency=medium

  * Version_2_7_2ore3

 -- Camm Maguire <camm@debian.org>  Sat, 03 May 2025 09:21:20 -0400

gcl27 (2.7.1-3) unstable; urgency=medium

  * Version_2_7_2ore2

 -- Camm Maguire <camm@debian.org>  Tue, 22 Apr 2025 20:39:18 -0400

gcl27 (2.7.1-2) unstable; urgency=medium

  * Version_2_7_2ore1

 -- Camm Maguire <camm@debian.org>  Fri, 11 Apr 2025 20:30:34 -0400

gcl27 (2.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Thu, 10 Apr 2025 21:39:17 -0400

gcl27 (2.7.0-36) unstable; urgency=medium

  * Version_2_7_0pre39

 -- Camm Maguire <camm@debian.org>  Mon, 24 Mar 2025 16:30:46 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
 Homepage: http://gnu.org/software/gcl
-Build-Depends: debhelper (>= 13), libeditreadline-dev, m4, tk8.6-dev, libgmp-dev, libxmu-dev, libxaw7-dev, po-debconf, zlib1g-dev, tcl, texinfo, texlive-latex-base, libtirpc-dev
+Build-Depends: debhelper-compat (= 13), libeditreadline-dev, m4, tk8.6-dev, libgmp-dev, libxmu-dev, libxaw7-dev, po-debconf, zlib1g-dev, tcl, texinfo, texlive-latex-extra, texlive-fonts-recommended, libtirpc-dev
 Build-Depends-Indep: dh-elpa
 Standards-Version: 4.5.0
 
@@ -53,6 +53,7 @@
 Conflicts: gclinfo
 Replaces: gclinfo
 Depends: dpkg (>= 1.15.4), ${misc:Depends}
+Multi-Arch: foreign
 Description: Documentation for GNU Common Lisp
  GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
  implemented in C, and complying mostly with the standard set 
@@ -69,6 +70,7 @@
 Conflicts: gclinfo
 Replaces: gclinfo
 Depends: dpkg (>= 1.15.4), ${misc:Depends}
+Multi-Arch: foreign
 Description: Documentation for GNU Common Lisp
  GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
  implemented in C, and complying mostly with the standard set

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
# GNU copyright 2024 Camm Maguire
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

#export GCL_MEM_MULTIPLE=0.1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(NUMJOBS))
MAKEFLAGS+=-j $(NUMJOBS) -O
GCL_MULTIPROCESS_MEMORY_POOL?=$(shell pwd)
export GCL_MULTIPROCESS_MEMORY_POOL
endif

# This is the debhelper compatability version to use.
ARCHT:=$(shell dpkg-architecture -qDEB_HOST_ARCH)

MCC?=gcc
# ifeq ($(ARCHT),alpha)
# MCC:=gcc-4.6
# endif

CFLAGS_APPEND?=
#ifeq ($(ARCHT),ppc64)
#CFLAGS_APPEND:=$(CFLAGS_APPEND) -O1
#endif

DEBUG?=
#ifeq ($(ARCHT),hppa)
#DEBUG=--enable-debug
#endif

VERS=$(shell echo $$(cat majvers).$$(cat minvers))
EXT=$(shell echo $(VERS) | sed 's,\([0-9]\)\.\([0-9]\)\..*,\1\2,')

debian/elpa-gcl$(EXT).elpa: debian/gcl$(EXT)-pkg.el
	find elisp -name "*.el" >$@
#	echo debian/gcl$(EXT).el >> debian/elpa-gcl$(EXT).elpa
	echo debian/gcl$(EXT)-pkg.el >> debian/elpa-gcl$(EXT).elpa
	echo debian/debian-autoloads.el >> debian/elpa-gcl$(EXT).elpa

VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)

debian/gcl$(EXT)-pkg.el: debian/gcl-pkg.el.in
	cat $< | sed "s,@VR@,$$(echo $(VR) | sed 's,[a-zA-Z]*,,g'),g" | sed "s,@EXT@,$(EXT),g" > $@


configure-stamp:

	dh_testdir

	dh_autoreconf

	eval `dpkg-buildflags --export=sh` && \
	CC=$(MCC) CFLAGS="$$CFLAGS $(CFLAGS_APPEND)" ./configure \
		--host=$$(dpkg-architecture -qDEB_HOST_GNU_TYPE) \
		$(DEBUG) \
		--prefix=/usr

	touch $@

build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)
	$(MAKE) $(MAKEFLAGS) check
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: #build-stamp
	touch $@

DOC_STUBS=gcl$(EXT) gcl$(EXT)-si gcl$(EXT)-tk gcl$(EXT)-dwdoc
DOC_FILES=$(addsuffix  .info,$(DOC_STUBS))
DOC_FILES+=$(addsuffix .dvi,$(DOC_STUBS))
DOC_FILES+=$(addsuffix .pdf,$(DOC_STUBS))
DOC_FILES+=$(addsuffix .html,$(DOC_STUBS))
DOC_FFILES=$(addprefix info/,$(DOC_FILES))
EXT_TARGS=$(DOC_FFILES) man/man1/gcl$(EXT).1 bin/gcl$(EXT)

install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	$(MAKE) $(MAKEFLAGS) install-all DESTDIR=$$(pwd)/debian/tmp
	$(MAKE) $(MAKEFLAGS) $(EXT_TARGS)
	for i in $(EXT_TARGS); do \
		for j in $$i*; do \
			if [ -d $$j ] ; then l=d ; r=-r ; else l=f ; fi ; \
			k=$$(find debian/tmp -type $$l -name $$(echo $$(basename $$j) | sed 's,$(EXT),,g')); \
			[ "$$k" = "" ] || cp $$r $$j $$(dirname $$k) ; \
			echo $$i $$j $$k; \
			[ "$$k" = "" ] || chmod $$(dirname $$k)/$$(basename $$j) --reference=$$k ; \
			[ "$$k" = "" ] || rm $$r $$k ; \
		done ; \
	done
	mv debian/tmp/usr/share/doc/gcl debian/tmp/usr/share/doc/gcl$(EXT)
	touch $@

INS:=$(shell for i in `find debian -name "in.*"` ; do \
		echo $$i | sed 's,in.,,1' ; \
		done |\
	     sed "s,\([^x]gcl\),\1$(EXT),g")

gcl$(EXT)% : in.gcl%
	cat $< | sed -e 's,@EXT@,$(EXT),g' -e 's,@VERS@,$(VERS),g' >$@

debian/po/POTFILES.in: debian/po/in.POTFILES.in
	cat $< | sed -e 's,@EXT@,$(EXT),g' -e 's,@VERS@,$(VERS),g' >$@

debian/control: debian/control_$(EXT)
	cp $< $@

install: DH_OPTIONS:=
install: install-stamp debian/control $(INS)
	dh_installdirs
	dh_install

clean: debian/control debian/gcl$(EXT).templates debian/po/POTFILES.in
	dh_testdir
	dh_testroot
	debconf-updatepo

	! [ -e Makefile ] || $(MAKE) $(MAKEFLAGS) distclean

	dh_autoreconf_clean
	dh_clean

	for i in $(INS); do echo $^ | grep -q $$i || rm -rf $$i ; done
	rm -rf debian/substvars debian.upstream
	rm -rf *stamp build-indep
	rm -f  debian/elpa-gcl$(EXT).elpa debian/gcl$(EXT)-pkg.el
	rm -rf $(EXT_TARGS) info/gcl$(EXT)*.info* gcl_pool

debian-clean: debian/control debian/gcl$(EXT).templates debian/po/POTFILES.in
	dh_testdir
	dh_testroot
	debconf-updatepo

	dh_clean

	for i in $(INS); do echo $^ | grep -q $$i || rm -rf $$i ; done
	rm -rf debian/substvars debian.upstream
	rm -rf *stamp build-indep
	rm -f  debian/elpa-gcl$(EXT).elpa debian/gcl$(EXT)-pkg.el
	rm -rf $(EXT_TARGS) info/gcl$(EXT)*.info* gcl_pool



# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: DH_OPTIONS:=-i
binary-indep: build install debian/elpa-gcl$(EXT).elpa
	dh_testdir
	dh_testroot
	dh_elpa
	dh_installdocs
	dh_installinfo
	dh_installchangelogs ChangeLog
	dh_link
	dh_compress 
	dh_fixperms 
	dh_installdeb 
	dh_gencontrol 
	dh_md5sums 
	dh_builddeb 

binary-arch: DH_OPTIONS=-a
binary-arch: build install #debian/substvars
	dh_testdir 
	dh_testroot 
	dh_installdocs
	dh_installdebconf 
	sed -i -e 's,@EXT@,$(EXT),g' debian/gcl$(EXT)/DEBIAN/templates
	dh_installchangelogs ChangeLog 
	dh_strip  -Xlibgcl -Xlibansi_gcl -Xlibgcl_gprof -Xlibansi_gcl_gprof
	dh_lintian 
	dh_link 
	dh_compress 
	dh_fixperms 
	dh_installdeb 
	dh_shlibdeps 
	dh_gencontrol  -u"-Vgcc=$(MCC)"
	dh_md5sums 
	dh_builddeb 

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
.PRECIOUS: configure-trad-stamp configure-ansi-stamp configure-gprof-stamp configure-ansi-gprof-stamp
